> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/ios/changelogs/version-9/v9-2-0-79330.md).

# Version 9.2.0.79330 Changelog (February 11th, 2022)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

* Version: 9.2.0.79330
* Release Date: February 11th, 2022
* Built with Xcode 13.2.1 (13C100)

## New Features

* The PDF outline (Table of Contents) is now displayed using hierarchal disclosure triangles so that outline items at multiple levels can be viewed at the same time.

![](https://4149080208-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgY6xtY9ZQd9XMpvWlGM0%2Fuploads%2Fgit-blob-10779789272100d388c7902fcd39f3fe81162007%2F46391573029f64967b52f2850ab4abfbd50e54e0-2266x1488.png?alt=media)

* PDF outlines can now be created and edited from the `PTOutlineViewController`.
* A Fill & Sign toolbar adds tools that can be used to fill PDF forms in appearance only, ie are not interactive forms.

![](https://4149080208-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgY6xtY9ZQd9XMpvWlGM0%2Fuploads%2Fgit-blob-7deaf209e940051b718024a1fec07ac6b7775db3%2F10fc0b0e30cba5e79ffc287d2c56623623552d25-2266x1488.png?alt=media)

* Added a new Speak option to selecting text which will read the selected text aloud.
* Ability for the user to specify where new pages are inserted in the document (rather than always appending).
* Freehand highlight annotations are now erased point-by-point rather than as a single entity (just as Freehand/Ink annotations have been treated).
* Users can now duplicate pages from the thumbnails browser.

## New APIs

* Adds a `PTToolManagerDelegate` method to control the text that is copied to the pasteboard:
  * [`-[PTToolManagerDelegate toolManager:willCopyReturnedText:toPasteboard:]`](https://sdk.apryse.com/api/ios/protocols/pttoolmanagerdelegate.html#/c:objc\(pl\)PTToolManagerDelegate\(im\)toolManager:willCopyReturnedText:toPasteboard:)
  * [`-[PTToolManagerDelegate toolManager:didCopyText:toPasteboard:]`](https://sdk.apryse.com/api/ios/protocols/pttoolmanagerdelegate.html#/c:objc\(pl\)PTToolManagerDelegate\(im\)toolManager:didCopyText:toPasteboard:)
* `PTNoteEditController` can now be subclassed.
* Adds a new API to specify a filename when exporting a document from the viewer:
  * [`-[PTDocumentBaseViewController shareCopy:withFlattening:targetFileName:]`](https://sdk.apryse.com/api/ios/Classes/PTDocumentBaseViewController.html#/c:objc\(cs\)PTDocumentBaseViewController\(im\)shareCopy:withFlattening:targetFileName:)
* Adds a new `PTToolManagerDelegate` callback for responding to page rotation events:
  * [`-[PTToolManagerDelegate toolManager:willRotatePagesForPageNumbers:]`](https://sdk.apryse.com/api/ios/Protocols/PTToolManagerDelegate.html#/c:objc\(pl\)PTToolManagerDelegate\(im\)toolManager:willRotatePagesForPageNumbers:)
  * [`-[PTToolManagerDelegate toolManager:didRotatePagesForPageNumbers:]`](https://sdk.apryse.com/api/ios/Protocols/PTToolManagerDelegate.html#/c:objc\(pl\)PTToolManagerDelegate\(im\)toolManager:didRotatePagesForPageNumbers:)
* Adds APIs to allow more control over Undo/Redo actions.

This release of Apryse for iOS brings the core PDF functionality inline with version 9.2 of the Apryse cross-platform APIs.

## Bug fixes

* Fixes a visual glitch where additional strokes were being added when drawing freehand annotations.
* Fixes a rare crash in the thumbnails browser.
* Fixes an issue where Freetext annotations were saved to the wrong location when writing in a right-to-left language.
* Prevents annotations from being erased by `PTEraser` if the user doesn't have edit permissions for the annotation.
* Fixes a bug where the annotation menu might appear when there is no annotation selected.
* Resolves some Auto Layout conflicts which were generating warnings in the console.
* Fixes an issue where annotations might be misplaced when the user rotates from portrait to landscape.
* Fixes an issue where form fields on imported/duplicated pages could not be edited.
* The popover showing an annotation's note is no longer anchored to the wrong point when the device is rotated.
* Fixes an issue where line annotations were slightly mispositioned after being moved.
* Fixes a crash when deleting certain annotations from malformed documents.
* Fixes an issue where users couldn't select more than one entry in a multi-select form field.
* Fixes a situation where save flags were not always respected.

\*Some features in the cross-platform APIs are not currently available on mobile, this includes the `Structured Output Module`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/ios/changelogs/version-9/v9-2-0-79330.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
